diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-mac-queue-container.h ns-3.39/src/wifi/model/wifi-mac-queue-container.h
--- ns-3.38/src/wifi/model/wifi-mac-queue-container.h	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/wifi-mac-queue-container.h	2023-07-05 14:23:48.121428500 -0700
@@ -37,37 +37,46 @@
 {
     WIFI_CTL_QUEUE = 0,
     WIFI_MGT_QUEUE = 1,
-    WIFI_QOSDATA_UNICAST_QUEUE = 2,
-    WIFI_QOSDATA_BROADCAST_QUEUE = 3,
-    WIFI_DATA_QUEUE = 4
+    WIFI_QOSDATA_QUEUE = 2,
+    WIFI_DATA_QUEUE = 3
+};
+
+/// enumeration of frame directions
+enum WifiReceiverAddressType : uint8_t
+{
+    WIFI_UNICAST = 0,
+    WIFI_BROADCAST
 };
 
 /**
- * Tuple (queue type, Address, TID) identifying a container queue.
+ * Tuple (queue type, receiver address type, Address, TID) identifying a container queue.
  *
  * \note that Address has a different meaning depending on container queue type:
- * - if container queue type is WIFI_CTL_QUEUE, Address is the Transmitter Address
- * (TA) of the frames stored in the queue. We have distinct control queues
- * depending on TA to distinguish among control frames that need to be sent
- * over different links by 11be MLDs. MLD address as TA indicates that the frames
- * can be sent on any link. TID is ignored.
- * - if container queue type is WIFI_MGT_QUEUE, Address is the Transmitter Address
- * (TA) of the frames stored in the queue. We have distinct management queues
- * depending on TA to distinguish among management frames that need to be sent
- * over different links by 11be MLDs. TID is ignored.
- * - if container queue type is WIFI_QOSDATA_UNICAST_QUEUE, Address is the Receiver
- * Address (RA) of the frames stored in the queue.
- * - if container queue type is WIFI_QOSDATA_BROADCAST_QUEUE, Address is the
- * Transmitter Address (TA) of the frames stored in the queue. We have distinct
- * broadcast QoS queues depending on TA to distinguish among broadcast QoS Data
- * frames that need to be sent over different links by 11be MLDs.
- * - if container queue type is WIFI_DATA_QUEUE, Address is the Receiver Address
- * (RA) of the frames stored in the queue. We do not need to consider the
- * Transmitter Address (TA) because 11be stations are QoS stations and hence do
- * not send non-QoS Data frames. TID is ignored.
+ *
+ * - for container queue types holding unicast frames, Address is the Receiver Address (RA)
+ *   of the frames stored in the queue. For 11be MLDs, it is expected that:
+ *   + the RA of unicast management frames are link addresses (indicating the link on which
+ *     they must be sent)
+ *   + the RA of unicast QoS data frames are MLD addresses (indicating that they can be sent
+ *     on any link)
+ *   + if the RA of a unicast control frame is a link address, that control frame can only be
+ *     sent on the corresponding link; if the RA is an MLD address, that control frame can be
+ *     sent on any link
+ *
+ * - for container queue types holding broadcast frames, Address is the Transmitter Address (TA)
+ *   of the frames stored in the queue. For 11be MLDs, it is expected that:
+ *   + the TA of broadcast management frames are link addresses (indicating the link on which
+ *     they must be sent)
+ *   + the TA of broadcast QoS data frames are MLD addresses (indicating that they can be sent
+ *     on any link)
+ *   + if the TA of a broadcast control frame is a link address, that control frame can only be
+ *     sent on the corresponding link; if the TA is an MLD address, that control frame can be
+ *     sent on any link
+ *
+ * The TID is only specified for container queue types holding QoS data frames.
  */
-using WifiContainerQueueId =
-    std::tuple<WifiContainerQueueType, Mac48Address, std::optional<uint8_t>>;
+using WifiContainerQueueId = std::
+    tuple<WifiContainerQueueType, WifiReceiverAddressType, Mac48Address, std::optional<uint8_t>>;
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-mac-queue.h ns-3.39/src/wifi/model/wifi-mac-queue.h
--- ns-3.38/src/wifi/model/wifi-mac-queue.h	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-mac-queue.h	2023-07-05 14:23:48.121428500 -0700
@@ -35,7 +35,6 @@
 namespace ns3
 {
 
-class QosBlockedDestinations;
 class WifiMacQueueScheduler;
 
 // The following explicit template instantiation declaration prevents modules
@@ -190,15 +189,11 @@
      * The packet is not removed from queue.
      *
      * \param linkId the ID of the given link
-     * \param blockedPackets the destination address & TID pairs that are waiting for a
-     * BlockAck response
      * \param item the item after which the search starts from
      *
      * \return the peeked packet or nullptr if no packet was found
      */
-    Ptr<WifiMpdu> PeekFirstAvailable(uint8_t linkId,
-                                     const Ptr<QosBlockedDestinations> blockedPackets = nullptr,
-                                     Ptr<const WifiMpdu> item = nullptr) const;
+    Ptr<WifiMpdu> PeekFirstAvailable(uint8_t linkId, Ptr<const WifiMpdu> item = nullptr) const;
     /**
      * Remove the packet in the front of the queue.
      *
@@ -290,6 +285,14 @@
      */
     Ptr<WifiMpdu> GetOriginal(Ptr<WifiMpdu> mpdu);
 
+    /**
+     * \param mpdu the given MPDU
+     * \param linkId the ID of the given link
+     * \return the alias of the given MPDU that is inflight on the given link, if any, or
+     *         a null pointer, otherwise
+     */
+    Ptr<WifiMpdu> GetAlias(Ptr<const WifiMpdu> mpdu, uint8_t linkId);
+
   protected:
     using Queue<WifiMpdu, WifiMacQueueContainer>::GetContainer;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-mac-queue-scheduler.h ns-3.39/src/wifi/model/wifi-mac-queue-scheduler.h
--- ns-3.38/src/wifi/model/wifi-mac-queue-scheduler.h	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/wifi-mac-queue-scheduler.h	2023-07-05 14:23:48.121428500 -0700
@@ -25,6 +25,7 @@
 
 #include "ns3/object.h"
 
+#include <bitset>
 #include <optional>
 
 namespace ns3
@@ -36,6 +37,48 @@
 /**
  * \ingroup wifi
  *
+ * Enumeration of the reasons to block container queues.
+ */
+enum class WifiQueueBlockedReason : uint8_t
+{
+    WAITING_ADDBA_RESP = 0,
+    POWER_SAVE_MODE,
+    USING_OTHER_EMLSR_LINK,
+    WAITING_EMLSR_TRANSITION_DELAY,
+    REASONS_COUNT
+};
+
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the stream
+ * \param reason the reason to block container queues
+ * \returns a reference to the stream
+ */
+inline std::ostream&
+operator<<(std::ostream& os, WifiQueueBlockedReason reason)
+{
+    switch (reason)
+    {
+    case WifiQueueBlockedReason::WAITING_ADDBA_RESP:
+        return (os << "WAITING_ADDBA_RESP");
+    case WifiQueueBlockedReason::POWER_SAVE_MODE:
+        return (os << "POWER_SAVE_MODE");
+    case WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK:
+        return (os << "USING_OTHER_EMLSR_LINK");
+    case WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY:
+        return (os << "WAITING_EMLSR_TRANSITION_DELAY");
+    case WifiQueueBlockedReason::REASONS_COUNT:
+        return (os << "REASONS_COUNT");
+    default:
+        NS_ABORT_MSG("Unknown queue blocked reason");
+        return (os << "unknown");
+    }
+}
+
+/**
+ * \ingroup wifi
+ *
  * WifiMacQueueScheduler is an abstract base class defining the public interface
  * for a wifi MAC queue scheduler.
  */
@@ -81,25 +124,74 @@
         const WifiContainerQueueId& prevQueueId) = 0;
 
     /**
-     * Get the list of the IDs of the links the given container queue (belonging to
-     * the given Access Category) is associated with.
+     * Get the list of the IDs of the links the given MPDU (belonging to the given
+     * Access Category) can be sent over.
      *
      * \param ac the given Access Category
-     * \param queueId the given container queue
-     * \return the list of the IDs of the links the given container queue is associated with
+     * \param mpdu the given MPDU
+     * \return the list of the IDs of the links the given MPDU can be sent over
      */
-    virtual std::list<uint8_t> GetLinkIds(AcIndex ac, const WifiContainerQueueId& queueId) = 0;
+    virtual std::list<uint8_t> GetLinkIds(AcIndex ac, Ptr<const WifiMpdu> mpdu) = 0;
+
     /**
-     * Set the list of the IDs of the links the given container queue (belonging to
-     * the given Access Category) is associated with.
+     * Block the given set of links for the container queues of the given types and
+     * Access Category that hold frames having the given Receiver Address (RA),
+     * Transmitter Address (TA) and TID (if needed) for the given reason, such that
+     * frames in these queues are not transmitted on the given set of links.
      *
+     * \param reason the reason for blocking the queues
      * \param ac the given Access Category
-     * \param queueId the given container queue
-     * \param linkIds the list of the IDs of the links the given container queue is associated with
-     */
-    virtual void SetLinkIds(AcIndex ac,
-                            const WifiContainerQueueId& queueId,
-                            const std::list<uint8_t>& linkIds) = 0;
+     * \param types the types of the queues to block
+     * \param rxAddress the Receiver Address (RA) of the frames
+     * \param txAddress the Transmitter Address (TA) of the frames
+     * \param tids the TIDs optionally identifying the queues to block
+     * \param linkIds set of links to block (empty to block all setup links)
+     */
+    virtual void BlockQueues(WifiQueueBlockedReason reason,
+                             AcIndex ac,
+                             const std::list<WifiContainerQueueType>& types,
+                             const Mac48Address& rxAddress,
+                             const Mac48Address& txAddress,
+                             const std::set<uint8_t>& tids = {},
+                             const std::set<uint8_t>& linkIds = {}) = 0;
+    /**
+     * Unblock the given set of links for the container queues of the given types and
+     * Access Category that hold frames having the given Receiver Address (RA),
+     * Transmitter Address (TA) and TID (if needed) for the given reason, such that
+     * frames in these queues can be transmitted on the given set of links.
+     *
+     * \param reason the reason for unblocking the queues
+     * \param ac the given Access Category
+     * \param types the types of the queues to unblock
+     * \param rxAddress the Receiver Address (RA) of the frames
+     * \param txAddress the Transmitter Address (TA) of the frames
+     * \param tids the TIDs optionally identifying the queues to unblock
+     * \param linkIds set of links to unblock (empty to unblock all setup links)
+     */
+    virtual void UnblockQueues(WifiQueueBlockedReason reason,
+                               AcIndex ac,
+                               const std::list<WifiContainerQueueType>& types,
+                               const Mac48Address& rxAddress,
+                               const Mac48Address& txAddress,
+                               const std::set<uint8_t>& tids = {},
+                               const std::set<uint8_t>& linkIds = {}) = 0;
+
+    /// Bitset identifying the reasons to block individual links for a container queue
+    using Mask = std::bitset<static_cast<std::size_t>(WifiQueueBlockedReason::REASONS_COUNT)>;
+
+    /**
+     * Get the mask associated with the given container queue indicating whether the given link
+     * is blocked and for which reason, provided that the given container queue exists and has
+     * a mask for the given link.
+     *
+     * \param ac the given Access Category
+     * \param queueId the ID of the given container queue
+     * \param linkId the ID of the given link
+     * \return the mask associated with the given container queue for the given link
+     */
+    virtual std::optional<Mask> GetQueueLinkMask(AcIndex ac,
+                                                 const WifiContainerQueueId& queueId,
+                                                 uint8_t linkId) = 0;
 
     /**
      * Check whether an MPDU has to be dropped before enqueuing the given MPDU.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-mac-queue-scheduler-impl.h ns-3.39/src/wifi/model/wifi-mac-queue-scheduler-impl.h
--- ns-3.38/src/wifi/model/wifi-mac-queue-scheduler-impl.h	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/wifi-mac-queue-scheduler-impl.h	2023-07-05 14:23:48.121428500 -0700
@@ -73,11 +73,27 @@
                                                 uint8_t linkId,
                                                 const WifiContainerQueueId& prevQueueId) final;
     /** \copydoc ns3::WifiMacQueueScheduler::GetLinkIds */
-    std::list<uint8_t> GetLinkIds(AcIndex ac, const WifiContainerQueueId& queueId) final;
-    /** \copydoc ns3::WifiMacQueueScheduler::SetLinkIds */
-    void SetLinkIds(AcIndex ac,
-                    const WifiContainerQueueId& queueId,
-                    const std::list<uint8_t>& linkIds) final;
+    std::list<uint8_t> GetLinkIds(AcIndex ac, Ptr<const WifiMpdu> mpdu) final;
+    /** \copydoc ns3::WifiMacQueueScheduler::BlockQueues */
+    void BlockQueues(WifiQueueBlockedReason reason,
+                     AcIndex ac,
+                     const std::list<WifiContainerQueueType>& types,
+                     const Mac48Address& rxAddress,
+                     const Mac48Address& txAddress,
+                     const std::set<uint8_t>& tids,
+                     const std::set<uint8_t>& linkIds) final;
+    /** \copydoc ns3::WifiMacQueueScheduler::UnblockQueues */
+    void UnblockQueues(WifiQueueBlockedReason reason,
+                       AcIndex ac,
+                       const std::list<WifiContainerQueueType>& types,
+                       const Mac48Address& rxAddress,
+                       const Mac48Address& txAddress,
+                       const std::set<uint8_t>& tids,
+                       const std::set<uint8_t>& linkIds) final;
+    /** \copydoc ns3::WifiMacQueueScheduler::GetQueueLinkMask */
+    std::optional<Mask> GetQueueLinkMask(AcIndex ac,
+                                         const WifiContainerQueueId& queueId,
+                                         uint8_t linkId) final;
     /** \copydoc ns3::WifiMacQueueScheduler::HasToDropBeforeEnqueue */
     Ptr<WifiMpdu> HasToDropBeforeEnqueue(AcIndex ac, Ptr<WifiMpdu> mpdu) final;
     /** \copydoc ns3::WifiMacQueueScheduler::NotifyEnqueue */
@@ -130,11 +146,12 @@
     struct QueueInfo
     {
         std::optional<typename SortedQueues::iterator>
-            priorityIt;             /**< iterator pointing to the entry
-                                         for this queue in the sorted list */
-        std::list<uint8_t> linkIds; /**< IDs of the links over which packets contained in this
-                                         queue can be sent over. Empty means that packets in this
-                                         queue can be sent over any link */
+            priorityIt;                  /**< iterator pointing to the entry
+                                              for this queue in the sorted list */
+        std::map<uint8_t, Mask> linkIds; /**< Maps ID of each link on which packets contained
+                                              in this queue can be sent to a bitset indicating
+                                              whether the link is blocked (at least one bit is
+                                              non-zero) and for which reason */
     };
 
     /**
@@ -167,16 +184,17 @@
 
   private:
     /**
-     * Add the information associated with the given container queue (if not already
-     * present) to the map corresponding to the given Access Category and Initialize
-     * the list of the IDs of the links over which packets contained in the given
-     * container queue can be sent over.
+     * If no information for the container queue used to store the given MPDU of the given
+     * Access Category is present in the queue info map, add the information for such a
+     * container queue and initialize the list of the IDs of the links over which packets
+     * contained in that container queue can be sent.
      *
      * \param ac the given Access Category
-     * \param queueId the ID of the given container queue
-     * \return an iterator to the information associated with the given container queue
+     * \param mpdu the given MPDU
+     * \return an iterator to the information associated with the container queue used to
+     *         store the given MPDU of the given Access Category
      */
-    typename QueueInfoMap::iterator InitQueueInfo(AcIndex ac, const WifiContainerQueueId& queueId);
+    typename QueueInfoMap::iterator InitQueueInfo(AcIndex ac, Ptr<const WifiMpdu> mpdu);
 
     /**
      * Get the next queue to serve. The search starts from the given one. The returned
@@ -228,6 +246,29 @@
      */
     virtual void DoNotifyRemove(AcIndex ac, const std::list<Ptr<WifiMpdu>>& mpdus) = 0;
 
+    /**
+     * Block or unblock the given set of links for the container queues of the given types and
+     * Access Category that hold frames having the given Receiver Address (RA),
+     * Transmitter Address (TA) and TID (if needed) for the given reason.
+     *
+     * \param block true to block the queues, false to unblock
+     * \param reason the reason for blocking the queues
+     * \param ac the given Access Category
+     * \param types the types of the queues to block
+     * \param rxAddress the Receiver Address (RA) of the frames
+     * \param txAddress the Transmitter Address (TA) of the frames
+     * \param tids the TIDs optionally identifying the queues to block
+     * \param linkIds set of links to block (empty to block all setup links)
+     */
+    void DoBlockQueues(bool block,
+                       WifiQueueBlockedReason reason,
+                       AcIndex ac,
+                       const std::list<WifiContainerQueueType>& types,
+                       const Mac48Address& rxAddress,
+                       const Mac48Address& txAddress,
+                       const std::set<uint8_t>& tids,
+                       const std::set<uint8_t>& linkIds);
+
     std::vector<PerAcInfo> m_perAcInfo{AC_UNDEF}; //!< vector of per-AC information
     NS_LOG_TEMPLATE_DECLARE;                      //!< the log component
 };
@@ -293,32 +334,67 @@
 
 template <class Priority, class Compare>
 typename WifiMacQueueSchedulerImpl<Priority, Compare>::QueueInfoMap::iterator
-WifiMacQueueSchedulerImpl<Priority, Compare>::InitQueueInfo(AcIndex ac,
-                                                            const WifiContainerQueueId& queueId)
+WifiMacQueueSchedulerImpl<Priority, Compare>::InitQueueInfo(AcIndex ac, Ptr<const WifiMpdu> mpdu)
 {
-    NS_LOG_FUNCTION(this);
+    NS_LOG_FUNCTION(this << ac << *mpdu);
 
+    auto queueId = WifiMacQueueContainer::GetQueueId(mpdu);
     // insert queueId in the queue info map if not present yet
     auto [queueInfoIt, ret] = m_perAcInfo[ac].queueInfoMap.insert({queueId, QueueInfo()});
 
-    if (ret)
+    // Initialize/update the set of link IDs depending on the container queue type
+    if (GetMac() && GetMac()->GetNLinks() > 1 &&
+        mpdu->GetHeader().GetAddr2() == GetMac()->GetAddress())
     {
-        // The given queueid has just been inserted in the queue info map.
-        // Initialize the set of link IDs depending on the container queue type
-        auto queueType = std::get<WifiContainerQueueType>(queueId);
-        auto address = std::get<Mac48Address>(queueId);
-
-        if (queueType == WIFI_MGT_QUEUE ||
-            (queueType == WIFI_CTL_QUEUE && GetMac() && address != GetMac()->GetAddress()) ||
-            queueType == WIFI_QOSDATA_BROADCAST_QUEUE)
+        // this is an MLD and the TA field of the frame contains the MLD address,
+        // which means that the frame can be sent on multiple links
+        const auto rxAddr = mpdu->GetHeader().GetAddr1();
+
+        // this assert checks that the RA field also contain an MLD address, unless
+        // it contains the broadcast address
+        NS_ASSERT_MSG(rxAddr.IsGroup() || GetMac()->GetMldAddress(rxAddr),
+                      "Address 1 (" << rxAddr << ") is not an MLD address");
+
+        // this assert checks that association (ML setup) has been established
+        // between sender and receiver (unless the receiver is the broadcast address)
+        NS_ASSERT_MSG(GetMac()->CanForwardPacketsTo(rxAddr), "Cannot forward frame to " << rxAddr);
+
+        // we have to include all the links in case of broadcast frame (we are an AP)
+        // and the links that have been setup with the receiver in case of unicast frame
+        for (uint8_t linkId = 0; linkId < GetMac()->GetNLinks(); linkId++)
         {
-            // these queue types are associated with just one link
-            NS_ASSERT(GetMac());
-            auto linkId = GetMac()->GetLinkIdByAddress(address);
-            NS_ASSERT(linkId.has_value());
-            queueInfoIt->second.linkIds = {*linkId};
+            if (rxAddr.IsGroup() ||
+                GetMac()->GetWifiRemoteStationManager(linkId)->GetAffiliatedStaAddress(rxAddr))
+            {
+                // the mask is not modified if linkId is already in the map
+                queueInfoIt->second.linkIds.emplace(linkId, Mask{});
+            }
+            else
+            {
+                // this link is no (longer) setup
+                queueInfoIt->second.linkIds.erase(linkId);
+            }
         }
     }
+    else
+    {
+        // the TA field of the frame contains a link address, which means that the
+        // frame can only be sent on the corresponding link
+        auto linkId = GetMac() ? GetMac()->GetLinkIdByAddress(mpdu->GetHeader().GetAddr2())
+                               : SINGLE_LINK_OP_ID; // make unit test happy
+        NS_ASSERT(linkId.has_value());
+        auto& linkIdsMap = queueInfoIt->second.linkIds;
+        NS_ASSERT_MSG(linkIdsMap.size() <= 1,
+                      "At most one link can be associated with this container queue");
+        // set the link map to contain one entry corresponding to the computed link ID;
+        // unless the link map already contained such an entry (in which case the mask
+        // is preserved)
+        if (linkIdsMap.empty() || linkIdsMap.cbegin()->first != *linkId)
+        {
+            linkIdsMap = {{*linkId, Mask{}}};
+        }
+    }
+
     return queueInfoIt;
 }
 
@@ -334,8 +410,9 @@
     NS_ABORT_MSG_IF(GetWifiMacQueue(ac)->GetNBytes(queueId) == 0,
                     "Cannot set the priority of an empty queue");
 
-    // insert queueId in the queue info map if not present yet
-    auto queueInfoIt = InitQueueInfo(ac, queueId);
+    auto queueInfoIt = m_perAcInfo[ac].queueInfoMap.find(queueId);
+    NS_ASSERT_MSG(queueInfoIt != m_perAcInfo[ac].queueInfoMap.end(),
+                  "No queue info for the given container queue");
     typename SortedQueues::iterator sortedQueuesIt;
 
     if (queueInfoIt->second.priorityIt.has_value())
@@ -363,31 +440,129 @@
 
 template <class Priority, class Compare>
 std::list<uint8_t>
-WifiMacQueueSchedulerImpl<Priority, Compare>::GetLinkIds(AcIndex ac,
-                                                         const WifiContainerQueueId& queueId)
+WifiMacQueueSchedulerImpl<Priority, Compare>::GetLinkIds(AcIndex ac, Ptr<const WifiMpdu> mpdu)
 {
-    auto queueInfoIt = InitQueueInfo(ac, queueId);
+    auto queueInfoIt = InitQueueInfo(ac, mpdu);
+    std::list<uint8_t> linkIds;
 
-    if (queueInfoIt->second.linkIds.empty())
+    // include only links that are not blocked in the returned list
+    for (const auto [linkId, mask] : queueInfoIt->second.linkIds)
     {
-        // return the IDs of all available links
-        NS_ASSERT(GetMac() != nullptr);
-        std::list<uint8_t> linkIds(GetMac()->GetNLinks());
-        std::iota(linkIds.begin(), linkIds.end(), 0);
-        return linkIds;
+        if (mask.none())
+        {
+            linkIds.emplace_back(linkId);
+        }
     }
-    return queueInfoIt->second.linkIds;
+
+    return linkIds;
 }
 
 template <class Priority, class Compare>
 void
-WifiMacQueueSchedulerImpl<Priority, Compare>::SetLinkIds(AcIndex ac,
-                                                         const WifiContainerQueueId& queueId,
-                                                         const std::list<uint8_t>& linkIds)
+WifiMacQueueSchedulerImpl<Priority, Compare>::DoBlockQueues(
+    bool block,
+    WifiQueueBlockedReason reason,
+    AcIndex ac,
+    const std::list<WifiContainerQueueType>& types,
+    const Mac48Address& rxAddress,
+    const Mac48Address& txAddress,
+    const std::set<uint8_t>& tids,
+    const std::set<uint8_t>& linkIds)
 {
-    NS_LOG_FUNCTION(this << +ac);
-    auto [queueInfoIt, ret] = m_perAcInfo[ac].queueInfoMap.insert({queueId, QueueInfo()});
-    queueInfoIt->second.linkIds = linkIds;
+    NS_LOG_FUNCTION(this << block << reason << ac << rxAddress << txAddress);
+    std::list<WifiMacHeader> headers;
+
+    for (const auto queueType : types)
+    {
+        switch (queueType)
+        {
+        case WIFI_CTL_QUEUE:
+            headers.emplace_back(WIFI_MAC_CTL_BACKREQ);
+            break;
+        case WIFI_MGT_QUEUE:
+            headers.emplace_back(WIFI_MAC_MGT_ACTION);
+            break;
+        case WIFI_QOSDATA_QUEUE:
+            NS_ASSERT_MSG(!tids.empty(),
+                          "TID must be specified for queues containing QoS data frames");
+            for (const auto tid : tids)
+            {
+                headers.emplace_back(WIFI_MAC_QOSDATA);
+                headers.back().SetQosTid(tid);
+            }
+            break;
+        case WIFI_DATA_QUEUE:
+            headers.emplace_back(WIFI_MAC_DATA);
+            break;
+        }
+    }
+    for (auto& hdr : headers)
+    {
+        hdr.SetAddr1(rxAddress);
+        hdr.SetAddr2(txAddress);
+
+        auto queueInfoIt = InitQueueInfo(ac, Create<WifiMpdu>(Create<Packet>(), hdr));
+        for (auto& [linkId, mask] : queueInfoIt->second.linkIds)
+        {
+            if (linkIds.empty() || linkIds.count(linkId) > 0)
+            {
+                mask.set(static_cast<std::size_t>(reason), block);
+            }
+        }
+    }
+}
+
+template <class Priority, class Compare>
+void
+WifiMacQueueSchedulerImpl<Priority, Compare>::BlockQueues(
+    WifiQueueBlockedReason reason,
+    AcIndex ac,
+    const std::list<WifiContainerQueueType>& types,
+    const Mac48Address& rxAddress,
+    const Mac48Address& txAddress,
+    const std::set<uint8_t>& tids,
+    const std::set<uint8_t>& linkIds)
+{
+    DoBlockQueues(true, reason, ac, types, rxAddress, txAddress, tids, linkIds);
+}
+
+template <class Priority, class Compare>
+void
+WifiMacQueueSchedulerImpl<Priority, Compare>::UnblockQueues(
+    WifiQueueBlockedReason reason,
+    AcIndex ac,
+    const std::list<WifiContainerQueueType>& types,
+    const Mac48Address& rxAddress,
+    const Mac48Address& txAddress,
+    const std::set<uint8_t>& tids,
+    const std::set<uint8_t>& linkIds)
+{
+    DoBlockQueues(false, reason, ac, types, rxAddress, txAddress, tids, linkIds);
+}
+
+template <class Priority, class Compare>
+std::optional<WifiMacQueueScheduler::Mask>
+WifiMacQueueSchedulerImpl<Priority, Compare>::GetQueueLinkMask(AcIndex ac,
+                                                               const WifiContainerQueueId& queueId,
+                                                               uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << +ac << +linkId);
+
+    const auto queueInfoIt = m_perAcInfo[ac].queueInfoMap.find(queueId);
+
+    if (queueInfoIt == m_perAcInfo[ac].queueInfoMap.cend())
+    {
+        // the given container queue does not exist
+        return std::nullopt;
+    }
+
+    const auto& linkIds = queueInfoIt->second.linkIds;
+    if (const auto linkIt = linkIds.find(linkId); linkIt != linkIds.cend())
+    {
+        return linkIt->second;
+    }
+
+    return std::nullopt;
 }
 
 template <class Priority, class Compare>
@@ -431,7 +606,8 @@
         const auto& queueInfoPair = sortedQueuesIt->second.get();
         const auto& linkIds = queueInfoPair.second.linkIds;
 
-        if (linkIds.empty() || std::find(linkIds.begin(), linkIds.end(), linkId) != linkIds.end())
+        if (const auto linkIt = linkIds.find(linkId);
+            linkIt != linkIds.cend() && linkIt->second.none())
         {
             // Packets in this queue can be sent over the link we got channel access on.
             // Now remove packets with expired lifetime from this queue.
@@ -482,12 +658,12 @@
     NS_LOG_FUNCTION(this << +ac << *mpdu);
     NS_ASSERT(static_cast<uint8_t>(ac) < AC_UNDEF);
 
+    // add information for the queue storing the MPDU to the queue info map, if not present yet
+    auto queueInfoIt = InitQueueInfo(ac, mpdu);
+
     DoNotifyEnqueue(ac, mpdu);
 
-    if (auto queueInfoIt =
-            m_perAcInfo[ac].queueInfoMap.find(WifiMacQueueContainer::GetQueueId(mpdu));
-        queueInfoIt == m_perAcInfo[ac].queueInfoMap.end() ||
-        !queueInfoIt->second.priorityIt.has_value())
+    if (!queueInfoIt->second.priorityIt.has_value())
     {
         NS_ABORT_MSG(
             "No info for the queue the MPDU was stored into (forgot to call SetPriority()?)");
